Index: palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4471 2020-03-24 12:08:06Z schwenkel
 ! Bugfix in lpm_droplet_interactions_ptq
 ! 
@@ -164,5 +167,5 @@
                intermediate_timestep_count, intermediate_timestep_count_max,   &
                message_string, molecular_viscosity, ocean_mode,                &
-               particle_maximum_age, iran,                                     & 
+               particle_maximum_age, iran, restart_data_format_output,         &
                simulated_time, topography, dopts_time_count,                   &
                time_since_reference_point, rho_surface, u_gtrans, v_gtrans,    &
@@ -205,4 +208,7 @@
     USE random_function_mod,                                                   &
         ONLY:  random_function
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rrd_mpi_io, wrd_mpi_io
 
     USE statistics,                                                            &
@@ -402,5 +408,6 @@
 
     INTERFACE lpm_rrd_global
-       MODULE PROCEDURE lpm_rrd_global
+       MODULE PROCEDURE lpm_rrd_global_ftn
+       MODULE PROCEDURE lpm_rrd_global_mpi
     END INTERFACE lpm_rrd_global
 
@@ -3175,15 +3182,26 @@
  SUBROUTINE lpm_wrd_global
  
-    CALL wrd_write_string( 'curvature_solution_effects' ) 
-    WRITE ( 14 )  curvature_solution_effects
-
-    CALL wrd_write_string( 'interpolation_simple_corrector' )
-    WRITE ( 14 )  interpolation_simple_corrector
-
-    CALL wrd_write_string( 'interpolation_simple_predictor' )
-    WRITE ( 14 )  interpolation_simple_predictor
-
-    CALL wrd_write_string( 'interpolation_trilinear' )
-    WRITE ( 14 )  interpolation_trilinear
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       CALL wrd_write_string( 'curvature_solution_effects' )
+       WRITE ( 14 )  curvature_solution_effects
+
+       CALL wrd_write_string( 'interpolation_simple_corrector' )
+       WRITE ( 14 )  interpolation_simple_corrector
+
+       CALL wrd_write_string( 'interpolation_simple_predictor' )
+       WRITE ( 14 )  interpolation_simple_predictor
+
+       CALL wrd_write_string( 'interpolation_trilinear' )
+       WRITE ( 14 )  interpolation_trilinear
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       CALL wrd_mpi_io( 'curvature_solution_effects', curvature_solution_effects )
+       CALL wrd_mpi_io( 'interpolation_simple_corrector', interpolation_simple_corrector )
+       CALL wrd_mpi_io( 'interpolation_simple_predictor', interpolation_simple_predictor )
+       CALL wrd_mpi_io( 'interpolation_trilinear', interpolation_trilinear )
+
+    ENDIF
 
  END SUBROUTINE lpm_wrd_global
@@ -3193,7 +3211,7 @@
 ! Description:
 ! ------------
-!> This routine writes the respective restart data for the lpm.
+!> Read module-specific global restart data (Fortran binary format).
 !------------------------------------------------------------------------------! 
- SUBROUTINE lpm_rrd_global( found )
+ SUBROUTINE lpm_rrd_global_ftn( found )
  
     USE control_parameters,                            &
@@ -3218,10 +3236,4 @@
           READ ( 13 )  interpolation_trilinear
 
-!          CASE ( 'global_paramter' )
-!             READ ( 13 )  global_parameter
-!          CASE ( 'global_array' )
-!             IF ( .NOT. ALLOCATED( global_array ) )  ALLOCATE( global_array(1:10) )
-!             READ ( 13 )  global_array
-
        CASE DEFAULT
 
@@ -3230,5 +3242,20 @@
     END SELECT 
     
- END SUBROUTINE lpm_rrd_global
+ END SUBROUTINE lpm_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE lpm_rrd_global_mpi
+
+    CALL rrd_mpi_io( 'curvature_solution_effects', curvature_solution_effects )
+    CALL rrd_mpi_io( 'interpolation_simple_corrector', interpolation_simple_corrector )
+    CALL rrd_mpi_io( 'interpolation_simple_predictor', interpolation_simple_predictor )
+    CALL rrd_mpi_io( 'interpolation_trilinear', interpolation_trilinear )
+
+ END SUBROUTINE lpm_rrd_global_mpi
 
 
Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4450 2020-03-09 19:12:57Z suehring
 ! Missing from_file check
 !
@@ -234,5 +237,5 @@
                end_time, humidity, intermediate_timestep_count,                &
                initializing_actions, intermediate_timestep_count_max,          &
-               land_surface, max_masks, pt_surface,                            &
+               land_surface, max_masks, pt_surface, restart_data_format_output,                    &
                rho_surface, spinup, spinup_pt_mean, spinup_time,               &
                surface_pressure, timestep_scheme, tsc,                         &
@@ -286,4 +289,7 @@
         ONLY:  albedo, albedo_type, emissivity, force_radiation_call,          &
                radiation, radiation_scheme, unscheduled_radiation_calls
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rd_mpi_io_surface_filetypes, wrd_mpi_io, wrd_mpi_io_surface
 
     USE statistics,                                                            &
@@ -6490,161 +6496,208 @@
 
     CHARACTER (LEN=1) ::  dum    !< dummy to create correct string for creating variable string
+
     INTEGER(iwp)      ::  l      !< index variable for surface orientation
 
-    CALL wrd_write_string( 'ns_h_on_file_lsm' )
-    WRITE ( 14 )  surf_lsm_h%ns
-
-    CALL wrd_write_string( 'ns_v_on_file_lsm' )
-    WRITE ( 14 )  surf_lsm_v(0:3)%ns
-
-
-    IF ( ALLOCATED( c_liq_av ) )  THEN
-       CALL wrd_write_string( 'c_liq_av' )
-       WRITE ( 14 )  c_liq_av
+    INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< index for surface data (MPI-IO)
+
+    LOGICAL ::  surface_data_to_write  !< switch for MPI-I/O if PE has surface data to write
+
+
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       CALL wrd_write_string( 'ns_h_on_file_lsm' )
+       WRITE ( 14 )  surf_lsm_h%ns
+
+       CALL wrd_write_string( 'ns_v_on_file_lsm' )
+       WRITE ( 14 )  surf_lsm_v(0:3)%ns
+
+
+       IF ( ALLOCATED( c_liq_av ) )  THEN
+          CALL wrd_write_string( 'c_liq_av' )
+          WRITE ( 14 )  c_liq_av
+       ENDIF
+
+       IF ( ALLOCATED( c_soil_av ) )  THEN
+          CALL wrd_write_string( 'c_soil_av' )
+          WRITE ( 14 )  c_soil_av
+       ENDIF
+
+       IF ( ALLOCATED( c_veg_av ) )  THEN
+          CALL wrd_write_string( 'c_veg_av' )
+          WRITE ( 14 )  c_veg_av
+       ENDIF
+
+       IF ( ALLOCATED( lai_av ) )  THEN
+          CALL wrd_write_string( 'lai_av' )
+          WRITE ( 14 )  lai_av
+       ENDIF
+
+       IF ( ALLOCATED( m_liq_av ) )  THEN
+          CALL wrd_write_string( 'm_liq_av' )
+          WRITE ( 14 )  m_liq_av
+       ENDIF
+
+       IF ( ALLOCATED( m_soil_av ) )  THEN
+          CALL wrd_write_string( 'm_soil_av' )
+          WRITE ( 14 )  m_soil_av
+       ENDIF
+
+       IF ( ALLOCATED( qsws_liq_av ) )  THEN
+          CALL wrd_write_string( 'qsws_liq_av' )
+          WRITE ( 14 )  qsws_liq_av
+       ENDIF
+
+       IF ( ALLOCATED( qsws_soil_av ) )  THEN
+          CALL wrd_write_string( 'qsws_soil_av' )
+          WRITE ( 14 )  qsws_soil_av
+       ENDIF
+
+       IF ( ALLOCATED( qsws_veg_av ) )  THEN
+          CALL wrd_write_string( 'qsws_veg_av' )
+          WRITE ( 14 )  qsws_veg_av
+       ENDIF
+
+       IF ( ALLOCATED( t_soil_av ) )  THEN
+          CALL wrd_write_string( 't_soil_av' )
+          WRITE ( 14 )  t_soil_av
+       ENDIF
+
+       CALL wrd_write_string( 'lsm_start_index_h' )
+       WRITE ( 14 )  surf_lsm_h%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_h' )
+       WRITE ( 14 )  surf_lsm_h%end_index
+
+       CALL wrd_write_string( 't_soil_h' )
+       WRITE ( 14 )  t_soil_h%var_2d
+
+       DO  l = 0, 3
+
+          CALL wrd_write_string( 'lsm_start_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 't_soil_v(' // dum // ')' )
+          WRITE ( 14 )  t_soil_v(l)%var_2d
+
+       ENDDO
+
+       CALL wrd_write_string( 'lsm_start_index_h' )
+       WRITE ( 14 )  surf_lsm_h%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_h' )
+       WRITE ( 14 )  surf_lsm_h%end_index
+
+       CALL wrd_write_string( 'm_soil_h' )
+       WRITE ( 14 )  m_soil_h%var_2d
+
+       DO  l = 0, 3
+
+          CALL wrd_write_string( 'lsm_start_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 'm_soil_v(' // dum // ')' )
+          WRITE ( 14 )  m_soil_v(l)%var_2d
+
+       ENDDO
+
+       CALL wrd_write_string( 'lsm_start_index_h' )
+       WRITE ( 14 )  surf_lsm_h%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_h' )
+       WRITE ( 14 )  surf_lsm_h%end_index
+
+       CALL wrd_write_string( 'm_liq_h' )
+       WRITE ( 14 )  m_liq_h%var_1d
+
+       DO  l = 0, 3
+
+          CALL wrd_write_string( 'lsm_start_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 'm_liq_v(' // dum // ')' )
+          WRITE ( 14 )  m_liq_v(l)%var_1d
+
+       ENDDO
+
+       CALL wrd_write_string( 'lsm_start_index_h' )
+       WRITE ( 14 )  surf_lsm_h%start_index
+
+       CALL wrd_write_string( 'lsm_end_index_h' )
+       WRITE ( 14 )  surf_lsm_h%end_index
+
+       CALL wrd_write_string( 't_surface_h' )
+       WRITE ( 14 )  t_surface_h%var_1d
+
+       DO  l = 0, 3
+
+          CALL wrd_write_string( 'lsm_start_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%start_index
+
+          CALL wrd_write_string( 'lsm_end_index_v' )
+          WRITE ( 14 )  surf_lsm_v(l)%end_index
+
+          WRITE( dum, '(I1)')  l
+          CALL wrd_write_string( 't_surface_v(' // dum // ')' )
+          WRITE ( 14 )  t_surface_v(l)%var_1d
+
+       ENDDO
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       IF ( ALLOCATED( c_liq_av ) )  CALL wrd_mpi_io( 'c_liq_av',  c_liq_av )
+       IF ( ALLOCATED( c_soil_av ) )  CALL wrd_mpi_io( 'c_soil_av',  c_soil_av )
+       IF ( ALLOCATED( c_veg_av ) )  CALL wrd_mpi_io( 'c_veg_av',  c_veg_av )
+       IF ( ALLOCATED( lai_av ) )  CALL wrd_mpi_io( 'lai_av', lai_av )
+       IF ( ALLOCATED( m_liq_av ) )  CALL wrd_mpi_io( 'm_liq_av',  m_liq_av )
+       IF ( ALLOCATED( m_soil_av ) )  CALL wrd_mpi_io( 'm_soil_av', m_soil_av, nzb_soil, nzt_soil )
+       IF ( ALLOCATED( qsws_liq_av ) )  CALL wrd_mpi_io( 'qsws_liq_av', qsws_liq_av )
+       IF ( ALLOCATED( qsws_soil_av ) )  CALL wrd_mpi_io( 'qsws_soil_av', qsws_soil_av )
+       IF ( ALLOCATED( qsws_veg_av ) )  CALL wrd_mpi_io( 'qsws_veg_av', qsws_veg_av )
+       IF ( ALLOCATED( t_soil_av ) )  CALL wrd_mpi_io( 't_soil_av', t_soil_av, nzb_soil, nzt_soil )
+
+       CALL rd_mpi_io_surface_filetypes( surf_lsm_h%start_index, surf_lsm_h%end_index,             &
+                                         surface_data_to_write, global_start_index )
+
+       CALL wrd_mpi_io( 'lsm_start_index_h',  surf_lsm_h%start_index )
+       CALL wrd_mpi_io( 'lsm_end_index_h',  surf_lsm_h%end_index )
+       CALL wrd_mpi_io( 'lsm_global_start_index_h', global_start_index )
+       CALL wrd_mpi_io_surface ( 't_soil_h', t_soil_h%var_2d )
+       CALL wrd_mpi_io_surface( 'm_soil_h',  m_soil_h%var_2d )
+       CALL wrd_mpi_io_surface( 'm_liq_h', m_liq_h%var_1d )
+       CALL wrd_mpi_io_surface( 't_surface_h', t_surface_h%var_1d )
+
+       DO  l = 0, 3
+
+          WRITE( dum, '(I1)' )  l
+
+          CALL rd_mpi_io_surface_filetypes ( surf_lsm_v(l)%start_index, surf_lsm_v(l)%end_index,   &
+                                             surface_data_to_write, global_start_index )
+
+          CALL wrd_mpi_io( 'lsm_start_index_v_' //dum,  surf_lsm_v(l)%start_index )
+          CALL wrd_mpi_io( 'lsm_end_index_v_' //dum,  surf_lsm_v(l)%end_index )
+          CALL wrd_mpi_io( 'lsm_global_start_index_v_' //dum , global_start_index )
+
+          IF ( .NOT. surface_data_to_write )  CYCLE
+
+          CALL wrd_mpi_io_surface( 't_soil_v(' // dum // ')', t_soil_v(l)%var_2d  )
+          CALL wrd_mpi_io_surface( 'm_soil_v(' // dum // ')', m_soil_v(l)%var_2d )
+          CALL wrd_mpi_io_surface( 'm_liq_v(' // dum // ')',  m_liq_v(l)%var_1d )
+          CALL wrd_mpi_io_surface( 't_surface_v(' // dum // ')',  t_surface_v(l)%var_1d )
+
+       ENDDO
+
     ENDIF
-
-    IF ( ALLOCATED( c_soil_av ) )  THEN
-       CALL wrd_write_string( 'c_soil_av' )
-       WRITE ( 14 )  c_soil_av
-    ENDIF
-
-    IF ( ALLOCATED( c_veg_av ) )  THEN
-       CALL wrd_write_string( 'c_veg_av' )
-       WRITE ( 14 )  c_veg_av
-    ENDIF
-
-    IF ( ALLOCATED( lai_av ) )  THEN
-       CALL wrd_write_string( 'lai_av' )
-       WRITE ( 14 )  lai_av
-    ENDIF
-
-    IF ( ALLOCATED( m_liq_av ) )  THEN
-       CALL wrd_write_string( 'm_liq_av' )
-       WRITE ( 14 )  m_liq_av
-    ENDIF
-
-    IF ( ALLOCATED( m_soil_av ) )  THEN
-       CALL wrd_write_string( 'm_soil_av' )
-       WRITE ( 14 )  m_soil_av
-    ENDIF
-
-    IF ( ALLOCATED( qsws_liq_av ) )  THEN
-       CALL wrd_write_string( 'qsws_liq_av' )
-       WRITE ( 14 )  qsws_liq_av
-    ENDIF
-
-    IF ( ALLOCATED( qsws_soil_av ) )  THEN
-       CALL wrd_write_string( 'qsws_soil_av' )
-       WRITE ( 14 )  qsws_soil_av
-    ENDIF
-
-    IF ( ALLOCATED( qsws_veg_av ) )  THEN
-       CALL wrd_write_string( 'qsws_veg_av' )
-       WRITE ( 14 )  qsws_veg_av
-    ENDIF
-
-    IF ( ALLOCATED( t_soil_av ) )  THEN
-       CALL wrd_write_string( 't_soil_av' )
-       WRITE ( 14 )  t_soil_av
-    ENDIF
-
-    CALL wrd_write_string( 'lsm_start_index_h' )
-    WRITE ( 14 )  surf_lsm_h%start_index
-
-    CALL wrd_write_string( 'lsm_end_index_h' )
-    WRITE ( 14 )  surf_lsm_h%end_index
-
-    CALL wrd_write_string( 't_soil_h' )
-    WRITE ( 14 )  t_soil_h%var_2d
-
-
-
-    DO  l = 0, 3
-
-       CALL wrd_write_string( 'lsm_start_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%end_index
-
-       WRITE( dum, '(I1)')  l
-
-       CALL wrd_write_string( 't_soil_v(' // dum // ')' )
-       WRITE ( 14 )  t_soil_v(l)%var_2d
-
-    ENDDO
-
-    CALL wrd_write_string( 'lsm_start_index_h' )
-    WRITE ( 14 )  surf_lsm_h%start_index
-
-    CALL wrd_write_string( 'lsm_end_index_h' )
-    WRITE ( 14 )  surf_lsm_h%end_index
-
-    CALL wrd_write_string( 'm_soil_h' )
-    WRITE ( 14 )  m_soil_h%var_2d
-
-    DO  l = 0, 3
-
-       CALL wrd_write_string( 'lsm_start_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%end_index
-
-       WRITE( dum, '(I1)')  l
-
-       CALL wrd_write_string( 'm_soil_v(' // dum // ')' )
-       WRITE ( 14 )  m_soil_v(l)%var_2d
-
-    ENDDO
-
-    CALL wrd_write_string( 'lsm_start_index_h' )
-    WRITE ( 14 )  surf_lsm_h%start_index
-
-    CALL wrd_write_string( 'lsm_end_index_h' )
-    WRITE ( 14 )  surf_lsm_h%end_index
-
-    CALL wrd_write_string( 'm_liq_h' )
-    WRITE ( 14 )  m_liq_h%var_1d
-
-    DO  l = 0, 3
-
-       CALL wrd_write_string( 'lsm_start_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%end_index
-
-       WRITE( dum, '(I1)')  l
-
-       CALL wrd_write_string( 'm_liq_v(' // dum // ')' )
-       WRITE ( 14 )  m_liq_v(l)%var_1d
-
-    ENDDO
-
-    CALL wrd_write_string( 'lsm_start_index_h' )
-    WRITE ( 14 )  surf_lsm_h%start_index
-
-    CALL wrd_write_string( 'lsm_end_index_h' )
-    WRITE ( 14 )  surf_lsm_h%end_index
-
-    CALL wrd_write_string( 't_surface_h' )
-    WRITE ( 14 )  t_surface_h%var_1d
-
-    DO  l = 0, 3
-
-       CALL wrd_write_string( 'lsm_start_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%start_index
-
-       CALL wrd_write_string( 'lsm_end_index_v' )
-       WRITE ( 14 )  surf_lsm_v(l)%end_index
-
-       WRITE( dum, '(I1)')  l
-
-       CALL wrd_write_string( 't_surface_v(' // dum // ')' )
-       WRITE ( 14 )  t_surface_v(l)%var_1d
-
-    ENDDO
-
 
  END SUBROUTINE lsm_wrd_local
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 4494)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4414 2020-02-19 20:16:04Z suehring
 ! Add module interface for basic initialization of numerics.
 ! 
@@ -687,5 +690,6 @@
 
     INTERFACE module_interface_rrd_global
-       MODULE PROCEDURE module_interface_rrd_global
+       MODULE PROCEDURE module_interface_rrd_global_ftn
+       MODULE PROCEDURE module_interface_rrd_global_mpi
     END INTERFACE module_interface_rrd_global
 
@@ -1698,10 +1702,10 @@
 
 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read module-specific restart data globaly shared by all MPI ranks
-!------------------------------------------------------------------------------!
- SUBROUTINE module_interface_rrd_global( found )
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific restart data in Fortran binary format globaly shared by all MPI ranks
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_rrd_global_ftn( found )
 
 
@@ -1728,5 +1732,35 @@
 
 
- END SUBROUTINE module_interface_rrd_global
+ END SUBROUTINE module_interface_rrd_global_ftn
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific restart data in MPI format globaly shared by all MPI ranks
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_rrd_global_mpi
+
+
+    IF ( debug_output )  CALL debug_message( 'module-specific read global restart data', 'start' )
+
+    CALL dynamics_rrd_global
+
+    IF ( biometeorology )       CALL bio_rrd_global
+    IF ( bulk_cloud_model )     CALL bcm_rrd_global
+    IF ( virtual_flight )       CALL flight_rrd_global
+    IF ( gust_module_enabled )  CALL gust_rrd_global
+    IF ( particle_advection )   CALL lpm_rrd_global
+    IF ( ocean_mode )           CALL ocean_rrd_global
+    IF ( syn_turb_gen )         CALL stg_rrd_global
+    IF ( wind_turbine )         CALL wtm_rrd_global
+    IF ( surface_output )       CALL surface_data_output_rrd_global
+
+    IF ( user_module_enabled )  CALL user_rrd_global
+
+    IF ( debug_output )  CALL debug_message( 'module-specific read global restart data', 'end' )
+
+
+ END SUBROUTINE module_interface_rrd_global_mpi
 
 
@@ -1747,4 +1781,5 @@
     IF ( virtual_flight )       CALL flight_wrd_global
     IF ( gust_module_enabled )  CALL gust_wrd_global
+    IF ( particle_advection )   CALL lpm_wrd_global
     IF ( ocean_mode )           CALL ocean_wrd_global
     IF ( syn_turb_gen )         CALL stg_wrd_global
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 4494)
+++ palm/trunk/SOURCE/modules.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! +restart_data_format, restart_data_format_input|output, include_total_domain_boundaries
+! 
+! 4476 2020-03-27 12:56:41Z maronga
 ! Renamed variables for subgrids-scale model steering
 ! 
@@ -550,4 +553,7 @@
     CHARACTER (LEN=80)   ::  recycling_method_for_thermodynamic_quantities = 'turbulent_fluctuation'        !< namelist parameter
     CHARACTER (LEN=20)   ::  reference_state = 'initial_profile'          !< namelist parameter
+    CHARACTER (LEN=20)   ::  restart_data_format = 'fortran_binary'       !< namelist parameter
+    CHARACTER (LEN=20)   ::  restart_data_format_input = 'undefined'      !< namelist parameter
+    CHARACTER (LEN=20)   ::  restart_data_format_output = 'undefined'     !< namelist parameter
     CHARACTER (LEN=20)   ::  timestep_scheme = 'runge-kutta-3'            !< namelist parameter
     CHARACTER (LEN=20)   ::  turbulence_closure = '1.5-order'             !< namelist parameter
@@ -748,4 +754,5 @@
     LOGICAL ::  humidity = .FALSE.                               !< namelist parameter
     LOGICAL ::  humidity_remote = .FALSE.                        !< switch for receiving near-surface humidity flux (atmosphere-ocean coupling)
+    LOGICAL ::  include_total_domain_boundaries = .FALSE.        !< store outer boundaries in restart file (MPI-IO)
     LOGICAL ::  indoor_model = .FALSE.                           !< switch for indoor-climate and energy-demand model
     LOGICAL ::  kolmogorov_length_scale = .FALSE.                !< switch to activate calculations in flow_statistics for the kolmogorov length scale
Index: palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- palm/trunk/SOURCE/ocean_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/ocean_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4481 2020-03-31 18:55:54Z maronga
 ! vector directives added to force vectorization on Intel19 compiler
 ! 
@@ -84,5 +87,5 @@
     USE control_parameters,                                                    &
         ONLY:  atmos_ocean_sign, bottom_salinityflux,                          &
-               constant_top_salinityflux, ocean_mode, top_salinityflux,        &
+               constant_top_salinityflux, restart_data_format_output, ocean_mode, top_salinityflux, &
                wall_salinityflux, loop_optimization, ws_scheme_sca
 
@@ -97,4 +100,7 @@
     USE indices,                                                               &
         ONLY:  advc_flags_s, nxl, nxr, nyn, nys, nzb, nzt, wall_flags_total_0
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rrd_mpi_io, rrd_mpi_io_global_array, wrd_mpi_io, wrd_mpi_io_global_array
 
     USE surface_mod,                                                           &
@@ -221,5 +227,6 @@
 
     INTERFACE ocean_rrd_global
-       MODULE PROCEDURE ocean_rrd_global
+       MODULE PROCEDURE ocean_rrd_global_ftn
+       MODULE PROCEDURE ocean_rrd_global_mpi
     END INTERFACE ocean_rrd_global
 
@@ -1938,7 +1945,7 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the ocean module.
-!------------------------------------------------------------------------------!
- SUBROUTINE ocean_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE ocean_rrd_global_ftn( found )
 
 
@@ -2001,5 +2008,30 @@
     END SELECT
 
- END SUBROUTINE ocean_rrd_global
+ END SUBROUTINE ocean_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE ocean_rrd_global_mpi
+
+    CALL rrd_mpi_io( 'bc_sa_t', bc_sa_t )
+    CALL rrd_mpi_io( 'bottom_salinityflux', bottom_salinityflux )
+    CALL rrd_mpi_io( 'salinity', salinity )
+    CALL rrd_mpi_io_global_array( 'sa_init', sa_init )
+    CALL rrd_mpi_io( 'sa_surface', sa_surface )
+    CALL rrd_mpi_io_global_array( 'sa_vertical_gradient', sa_vertical_gradient )
+    CALL rrd_mpi_io_global_array( 'sa_vertical_gradient_level', sa_vertical_gradient_level )
+    CALL rrd_mpi_io_global_array( 'sa_vertical_gradient_level_ind', sa_vertical_gradient_level_ind )
+    CALL rrd_mpi_io( 'stokes_waveheight', stokes_waveheight )
+    CALL rrd_mpi_io( 'stokes_wavelength', stokes_wavelength )
+    CALL rrd_mpi_io( 'surface_cooling_spinup_time', surface_cooling_spinup_time )
+    CALL rrd_mpi_io( 'top_salinityflux', top_salinityflux )
+    CALL rrd_mpi_io_global_array( 'wall_salinityflux', wall_salinityflux )
+    CALL rrd_mpi_io( 'wave_breaking', wave_breaking )
+
+ END SUBROUTINE ocean_rrd_global_mpi
 
 
@@ -2086,45 +2118,66 @@
  SUBROUTINE ocean_wrd_global
 
-
-    IMPLICIT NONE
-
-    CALL wrd_write_string( 'bc_sa_t' )
-    WRITE ( 14 )  bc_sa_t
-
-    CALL wrd_write_string( 'bottom_salinityflux' )
-    WRITE ( 14 )  bottom_salinityflux
-
-    CALL wrd_write_string( 'salinity' )
-    WRITE ( 14 )  salinity
-
-    CALL wrd_write_string( 'sa_init' )
-    WRITE ( 14 )  sa_init
-
-    CALL wrd_write_string( 'sa_surface' )
-    WRITE ( 14 )  sa_surface
-
-    CALL wrd_write_string( 'sa_vertical_gradient' )
-    WRITE ( 14 )  sa_vertical_gradient
-
-    CALL wrd_write_string( 'sa_vertical_gradient_level' )
-    WRITE ( 14 )  sa_vertical_gradient_level
-
-    CALL wrd_write_string( 'stokes_waveheight' )
-    WRITE ( 14 )  stokes_waveheight
-
-    CALL wrd_write_string( 'stokes_wavelength' )
-    WRITE ( 14 )  stokes_wavelength
-
-    CALL wrd_write_string( 'surface_cooling_spinup_time' )
-    WRITE ( 14 )  surface_cooling_spinup_time
-
-    CALL wrd_write_string( 'top_salinityflux' )
-    WRITE ( 14 )  top_salinityflux
-
-    CALL wrd_write_string( 'wall_salinityflux' )
-    WRITE ( 14 )  wall_salinityflux
-
-    CALL wrd_write_string( 'wave_breaking' )
-    WRITE ( 14 )  wave_breaking
+    IMPLICIT NONE
+
+
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       CALL wrd_write_string( 'bc_sa_t' )
+       WRITE ( 14 )  bc_sa_t
+
+       CALL wrd_write_string( 'bottom_salinityflux' )
+       WRITE ( 14 )  bottom_salinityflux
+
+       CALL wrd_write_string( 'salinity' )
+       WRITE ( 14 )  salinity
+
+       CALL wrd_write_string( 'sa_init' )
+       WRITE ( 14 )  sa_init
+
+       CALL wrd_write_string( 'sa_surface' )
+       WRITE ( 14 )  sa_surface
+
+       CALL wrd_write_string( 'sa_vertical_gradient' )
+       WRITE ( 14 )  sa_vertical_gradient
+
+       CALL wrd_write_string( 'sa_vertical_gradient_level' )
+       WRITE ( 14 )  sa_vertical_gradient_level
+
+       CALL wrd_write_string( 'stokes_waveheight' )
+       WRITE ( 14 )  stokes_waveheight
+
+       CALL wrd_write_string( 'stokes_wavelength' )
+       WRITE ( 14 )  stokes_wavelength
+
+       CALL wrd_write_string( 'surface_cooling_spinup_time' )
+       WRITE ( 14 )  surface_cooling_spinup_time
+
+       CALL wrd_write_string( 'top_salinityflux' )
+       WRITE ( 14 )  top_salinityflux
+
+       CALL wrd_write_string( 'wall_salinityflux' )
+       WRITE ( 14 )  wall_salinityflux
+
+       CALL wrd_write_string( 'wave_breaking' )
+       WRITE ( 14 )  wave_breaking
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       CALL wrd_mpi_io( 'bc_sa_t', bc_sa_t )
+       CALL wrd_mpi_io( 'bottom_salinityflux', bottom_salinityflux )
+       CALL wrd_mpi_io( 'salinity', salinity )
+       CALL wrd_mpi_io_global_array( 'sa_init', sa_init )
+       CALL wrd_mpi_io( 'sa_surface', sa_surface )
+       CALL wrd_mpi_io_global_array( 'sa_vertical_gradient', sa_vertical_gradient )
+       CALL wrd_mpi_io_global_array( 'sa_vertical_gradient_level', sa_vertical_gradient_level )
+       CALL wrd_mpi_io_global_array( 'sa_vertical_gradient_level_ind', sa_vertical_gradient_level_ind )
+       CALL wrd_mpi_io( 'stokes_waveheight', stokes_waveheight )
+       CALL wrd_mpi_io( 'stokes_wavelength', stokes_wavelength )
+       CALL wrd_mpi_io( 'surface_cooling_spinup_time', surface_cooling_spinup_time )
+       CALL wrd_mpi_io( 'top_salinityflux', top_salinityflux )
+       CALL wrd_mpi_io_global_array( 'wall_salinityflux', wall_salinityflux )
+       CALL wrd_mpi_io( 'wave_breaking', wave_breaking )
+
+    ENDIF
 
  END SUBROUTINE ocean_wrd_global
@@ -2143,15 +2196,26 @@
     IMPLICIT NONE
 
-    IF ( ALLOCATED( rho_ocean_av ) )  THEN
-       CALL wrd_write_string( 'rho_ocean_av' )
-       WRITE ( 14 )  rho_ocean_av
-    ENDIF
-
-    CALL wrd_write_string( 'sa' )
-    WRITE ( 14 )  sa
-
-    IF ( ALLOCATED( sa_av ) )  THEN
-       CALL wrd_write_string( 'sa_av' )
-       WRITE ( 14 )  sa_av
+
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       IF ( ALLOCATED( rho_ocean_av ) )  THEN
+          CALL wrd_write_string( 'rho_ocean_av' )
+          WRITE ( 14 )  rho_ocean_av
+       ENDIF
+
+       CALL wrd_write_string( 'sa' )
+       WRITE ( 14 )  sa
+
+       IF ( ALLOCATED( sa_av ) )  THEN
+          CALL wrd_write_string( 'sa_av' )
+          WRITE ( 14 )  sa_av
+       ENDIF
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       IF ( ALLOCATED( rho_ocean_av ) )  CALL wrd_mpi_io( 'rho_ocean_av', rho_ocean_av )
+       CALL wrd_mpi_io( 'sa', sa )
+       IF ( ALLOCATED( sa_av ) )  CALL wrd_mpi_io( 'sa_av', sa_av )
+
     ENDIF
 
